/* Hue - A Hotline User Editor
 *
 * Copyright (C) 2000 Misha Nasledov <misha@nasledov.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

struct access_name {
	int bitno;
	char *name;
};

int number_open = 0;
int about_open = 0;
void menu_new(guint callback_data, guint callback_action, GtkWidget *widget);
void open_data (guint callback_data, guint callback_action, GtkWidget *widget);
void menu_save_as(guint callback_data, guint callback_action, GtkWidget *widget);
void save_user_menu (guint callback_data, guint callback_action, GtkWidget *widget);
void create_about_window(void);
int account_read (const char *path, char *login, char *password, char *name, struct hl_access_bits *acc);

#define ACCESS_NUM 28

typedef struct _Hue {
	struct _Hue *next, *prev;
	char *path;
	struct hl_access_bits acc;
	char login[32], password[32], name[32];
	GtkWidget *usermod_window;
	GtkWidget *check[ACCESS_NUM];
	GtkWidget *name_entry;
	GtkWidget *login_entry;
	GtkWidget *pass_entry;
} Hue;

Hue *hue_list;
Hue *hue_front;
Hue *hue_new(char *path);
Hue *create_usermod_window(Hue *hue);

GtkItemFactoryEntry menu_items[] = {
  {"/_File", NULL, 0, 0, "<Branch>" },
  {"/File/_New", "<control>N", menu_new, 0},
  {"/File/_sep1", NULL, NULL, 0, "<Separator>"},
  {"/File/_Open", "<control>O", open_data, 0},
  {"/File/_Save", "<control>S", save_user_menu, 0},
  {"/File/_Save As...", 0, menu_save_as, 0},
  {"/File/_sep2", NULL, NULL, 0, "<Separator>"},
  {"/File/_Quit", "<control>Q", gtk_main_quit, 0},

  {"/_Help", 0, 0, 0, "<LastBranch>"}, 
  {"/Help/_About", 0, create_about_window, 0}
  
};
int nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);

struct access_name user_values[]= {
	{ 1, "Can Upload Files"}, //0
	{ 2, "Can Download Files"}, //1
	{ 0, "Can Delete Files"}, //2
	{ 3, "Can Rename Files"}, //3
	{ 4, "Can Move Files"}, //4
	{ 5, "Can Create Folders"}, //5
	{ 6, "Can Delete Folders"}, //6
	{ 7, "Can Rename Folders"}, //7
	{ 8, "Can Move Folders"}, //8
	{ 9, "Can Read Chat"}, //9
	{ 10, "Can Send Chat"}, //10
	{ 14, "Can Create Users"}, //11
	{ 15, "Can Delete Users"}, //12
	{ 16, "Can Read Users"}, //13
	{ 17, "Can Modify Users"}, //14
	{ 20, "Can Read News"}, //15
	{ 21, "Can Post News"}, //16
	{ 22, "Can Disconnect Users"}, //17
	{ 23, "Cannot Be Disconnected"}, //18
	{ 24, "Can Get User Info"}, //19
	{ 25, "Can Upload Anywhere"}, //20
	{ 26, "Can Use Any Name"}, //21
	{ 27, "Can Not Be Shown Agreement"}, //22
	{ 28, "Can Comment Files"}, //23
	{ 29, "Can Comment Folders"}, //24
	{ 30, "Can View Drop Boxes"}, //25
	{ 31, "Can Make Aliases"}, //26
	{ 32, "Can Broadcast"}, //27
};
